{% extends 'dashboard/dashboard_content.html' %}

{% block title %}
    View Course
{% endblock %}

{% block head_block %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/css/select2.min.css" rel="stylesheet"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js"></script>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/css/bootstrap-select.min.css">

    <!-- Latest compiled and minified JavaScript -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/js/bootstrap-select.min.js"></script>


{% endblock %}

{% block rightPane %}
    <div class="x_panel">
        <div class="x_title">
            <h2>
                <i class="glyphicon glyphicon-pencil"></i>
                View Course
            </h2>
            <div class="clearfix"></div>
        </div>
        <ul class="nav navbar-nav navbar-right">
            <li>
                <button class="btn1 btn-orange" type="button" data-toggle="modal"
                        data-target="#myModal11">
                    Delete Course
                </button>
                <form method="POST">{% csrf_token %}
                    <div class="modal" id="myModal11" tabindex="-1" role="dialog"
                         aria-labelledby="myModalLabel1" aria-hidden="true">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                    <h4 class="modal-title" id="myModalLabel1"><b> Delete Confirmation </b></h4>
                                </div>
                                <div class="modal-body">
                                    <input id="deleteid" name="deleteid" value="{{ course.pk }}" hidden>
                                    <h5>Note: <strong style="color: red">Student enrolled and staff alloted for this course will be deleted</strong></h5>
                                    <h4 align="center">Contact Administrator to delete the course(for data loss prevention)</h4>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn1 btn1-default" data-dismiss="modal">Close
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </li>
        </ul>
        <div class="x_content">
            <div>
                <input id="selectedprogramme" value="{{ course.programme }}" hidden>
                <div class="table-responsive">
                    <table class="table table-hover">
                        <tr>
                            <th>Course ID</th>
                            <td>{{ course.course_id }}</td>
                            <th>Course Name</th>
                            <td>{{ course.course_name }}</td>
                        </tr>
                        <tr>
                            <th>Semester</th>
                            <td>
                                {{ course.semester }}
                            </td>
                            <th>Department</th>
                            <td>{{ course.department }}</td>
                        </tr>
                        <tr>
                            <th>Programme</th>
                            <td>{{ course.programme }}</td>
                            <th>Regulation</th>
                            <td>{{ course.regulation }}</td>
                        </tr>
                        <tr>
                            <th>CAT Marks</th>
                            <td>{{ course.CAT_marks }}</td>
                            <th>End Semester Marks</th>
                            <td>{{ course.end_semester_marks }}</td>
                        </tr>
                        <tr>
                            <th>Category</th>
                            <td>{{ course.subject_type }}</td>
                            <th>CAT</th>
                            <td>{{ course.CAT }}</td>
                        </tr>
                        <tr>
                            <th>L_credits</th>
                            <td>{{ course.L_credits }}</td>
                            <th>P_credits</th>
                            <td>{{ course.P_credits }}</td>
                        </tr>
                        <tr>
                            <th>T_credits</th>
                            <td>{{ course.T_credits }}</td>
                            <th>C_credits</th>
                            <td>{{ course.C_credits }}</td>
                        </tr>
                        <tr>

                            <th>Elective Course</th>
                            <td>
                                {% if course.is_elective %}
                                    <i class="glyphicon glyphicon-ok"></i>
                                {% else %}
                                    <i class="glyphicon glyphicon-remove"></i>
                                {% endif %}
                            </td>
                            <th>Open Course</th>
                            <td>
                                {% if course.is_open %}
                                    <i class="glyphicon glyphicon-ok"></i>
                                {% else %}
                                    <i class="glyphicon glyphicon-remove"></i>
                                {% endif %}
                            </td>
                        </tr>
                        <tr>
                            <th>Course Abbreviation</th>
                            <td>{{ course.code }}</td>
                            <th>One Credit Course</th>
                            <td>
                                {% if course.is_one_credit %}
                                    <i class="glyphicon glyphicon-ok"></i>
                                {% else %}
                                    <i class="glyphicon glyphicon-remove"></i>
                                {% endif %}
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </div>


        <div class="form-group">
            <label class="control-label col-md-3 col-sm-3 col-xs-12">
            </label>
            <div class="col-md-6 col-sm-6 col-xs-12">
                <button id="edit_btn" class="btn1 btn1-warning" type="button"
                        data-toggle="modal"
                        data-target="#myModal">
                    Edit Course
                </button>
                <form id="submit_form" method="POST">{% csrf_token %}
                    <div class="modal" id="myModal" tabindex="-1" role="dialog"
                         aria-labelledby="myModalLabel1" aria-hidden="true">
                        <div class="modal-dialog modal-lg" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                    <h4 class="modal-title" id="myModalLabel1"><b> Edit Course </b></h4>
                                </div>
                                <div class="modal-body">
                                    <div class="form-horizontal form-label-left">

                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                Regulation
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <select class="form-control" name="regulation" id="regulation"
                                                        required>
                                                    <option value="" disabled selected>Choose Regulation</option>
                                                    {% for regulation in list_of_regulations %}
                                                        {% if course.regulation == regulation %}
                                                            <option value="{{ regulation.pk }}"
                                                                    selected>{{ regulation }}</option>
                                                        {% else %}
                                                            <option value="{{ regulation.pk }}">{{ regulation }}</option>
                                                        {% endif %}
                                                    {% endfor %}
                                                </select>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                Course Type
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <div class="form-check">
                                                    <label class="form-check-label">
                                                        <input class="form-check-input" type="radio"
                                                               name="coursetype" value="normal"
                                                                {% if not course.is_elective %}
                                                                    {% if not course.is_open %}
                                                                        {% if not course.is_one_credit %}
                                                               checked
                                                                        {% endif %}
                                                                    {% endif %}
                                                                {% endif %}
                                                        >
                                                        Normal
                                                        <input class="form-check-input" type="radio"
                                                               name="coursetype" value="elective"
                                                                {% if course.is_elective %}
                                                               checked
                                                                {% endif %}
                                                        >
                                                        Elective
                                                        <input class="form-check-input" type="radio" name="coursetype"
                                                               value="open"
                                                                {% if course.is_open %}
                                                               checked
                                                                {% endif %}
                                                        >
                                                        Open
                                                        <input class="form-check-input" type="radio" name="coursetype"
                                                               value="onecredit"
                                                                {% if course.is_one_credit %}
                                                               checked
                                                                {% endif %}
                                                        >
                                                        One Credit
                                                    </label>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="form-group" id="departmenttab">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                Department
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <select class="form-control" name="department" id="department"
                                                        required>
                                                    <option value="" disabled selected>Choose Department</option>
                                                    {% for each in list_of_departments %}
                                                        {% if course.department.pk == each.pk %}
                                                            <option value="{{ each.pk }}"
                                                                    selected>{{ each.acronym }}</option>
                                                        {% else %}
                                                            <option value="{{ each.pk }}">{{ each.acronym }}</option>
                                                        {% endif %}
                                                    {% endfor %}
                                                </select>
                                            </div>
                                        </div>

                                        <div class="form-group" id="programmetab">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                Programme
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <select class="form-control" name="programme" id="programme"
                                                        required>
                                                    <option value="" disabled selected>Choose Programme</option>
                                                    {% if course.programme == 'UG' %}
                                                        <option value="UG" selected>Under Graduate</option>
                                                    {% else %}
                                                        <option value="UG">Under Graduate</option>
                                                    {% endif %}
                                                    {% if course.programme == 'PG' %}
                                                        <option value="PG" selected>Post Graduate</option>
                                                    {% else %}
                                                        <option value="PG">Post Graduate</option>
                                                    {% endif %}
                                                    {% if course.programme == 'Phd' %}
                                                        <option value="Phd" selected>Doctrate of Philosophy</option>
                                                    {% else %}
                                                        <option value="Phd">Doctrate of Philosophy</option>
                                                    {% endif %}
                                                </select>
                                            </div>
                                        </div>

                                        <div class="form-group" id="semestertab">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                Semester
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <select class="form-control" name="semester" id="semester" required>
                                                    <option value="" disabled selected>Choose Semester</option>
                                                </select>
                                            </div>
                                        </div>


                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                Course ID
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <input id="viewingid" name="originalid" value="{{ course.pk }}"
                                                       hidden>
{#                                                <input class="form-control" placeholder="Course Code" type="text"#}
                                                {#                                                       name="courseid" id="courseid" value="{{ course.course_id }}"#}
                                                {#                                                       maxlength="8" required>#}
                                                <label class="control-label">
                                                {{ course.course_id }}
                                            </label>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                Course Name
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <input class="form-control" placeholder="Name of the Course"
                                                       type="text" name="coursename" id="coursename"
                                                       value="{{ course.course_name }}" maxlength="150"
                                                       required>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                Subject Category
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <select class="form-control" name="subjecttype" id="subjecttype"
                                                        required>
                                                    <option value="" disabled selected>Choose Category</option>
                                                    {% if course.subject_type == 'T' %}
                                                        <option value="T" selected>Theory</option>
                                                    {% else %}
                                                        <option value="T">Theory</option>
                                                    {% endif %}
                                                    {% if course.subject_type == 'P' %}
                                                        <option value="P" selected>Practical</option>
                                                    {% else %}
                                                        <option value="P">Practical</option>
                                                    {% endif %}
                                                </select>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                CAT
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <select class="form-control" name="cat" id="cat" required>
                                                    <option value="" disabled selected>Choose CAT</option>

                                                    {% for each in available_CAT %}
                                                        {% if course.CAT == each %}
                                                            <option value="{{ each }}" selected>{{ each }}</option>
                                                        {% else %}
                                                            <option value="{{ each }}">{{ each }}</option>
                                                        {% endif %}
                                                    {% endfor %}
                                                </select>
                                            </div>
                                        </div>


                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                CAT Marks
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <input class="form-control" id="catmarks" name="catmarks"
                                                       maxlength="3" value="{{ course.CAT_marks }}"
                                                       onkeypress="return isNumberKey(event)" required>
                                            </div>
                                        </div>


                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                End Semester Marks
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <input class="form-control" type="text" name="endsemmarks"
                                                       id="endsemmarks" maxlength="3"
                                                       value="{{ course.end_semester_marks }}"
                                                       onkeypress="return isNumberKey(event)" required>
                                            </div>
                                        </div>


                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                L Credits
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <input class="form-control" type="text" name="lcredits"
                                                       id="lcredits" maxlength="3" value="{{ course.L_credits }}"
                                                       onkeypress="return isNumberKey(event)" required>
                                            </div>
                                        </div>


                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                T Credits
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <input class="form-control" type="text" name="tcredits"
                                                       id="tcredits" maxlength="3" value="{{ course.T_credits }}"
                                                       onkeypress="return isNumberKey(event)" required>
                                            </div>
                                        </div>


                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                P Credits
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <input class="form-control" type="text" name="pcredits"
                                                       id="pcredits" maxlength="3" value="{{ course.P_credits }}"
                                                       onkeypress="return isNumberKey(event)" required>
                                            </div>
                                        </div>


                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                C Credits
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <input class="form-control" placeholder=""
                                                       type="text" name="ccredits"
                                                       id="ccredits" maxlength="3" value="{{ course.C_credits }}"
                                                       onkeypress="return isNumberKey(event)" required>
                                            </div>
                                        </div>


                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                                Course Abbreviation
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <input class="form-control" placeholder="Shorthand code for Course"
                                                       type="text" name="code" id="code" value="{{ course.code }}"
                                                       maxlength="10">
                                            </div>
                                        </div>


                                        <div class="form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                            </label>
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <button name="updatecourse" type="submit" class="btn1 btn1-success">
                                                    Update Course
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn1 btn1-default" data-dismiss="modal">Close
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>



    <script type="text/javascript">

        $(document).on("change", '[name="coursetype"]', function (e) {
            $('#departmenttab').show();
            $('#programmetab').show();
            $('#semestertab').show();
            $('#programme').val('');
            $('#semester').empty();
            $('#semester').append('<option value="" disabled selected>Choose Semester</option>');
            $('#semester').val('');
        });

        $(document).on("change", '#department', function (e) {
            var department = $(this).val();
            var course_type = $("input[name=coursetype]:checked").val();
            //alert($("input[name=coursetype]:checked").val());

            $.ajax({
                type: "POST",
                data: {
                    department: department,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'add_course_to_db' %}',

                success: function (data) {
                    $('#programme').empty();
                    $('#programme').append('<option value="" disabled selected>Choose Programme</option>');
                    $('#programme').val('');
                    counter = 1;
                    $.each(data.list, function (key, val) {
                        $('#programme').append('<option value="' + val + '">' + val + '</option>');
                    })

                }
            });
        });

        $(document).on("change", '#programme', function (e) {
            var programme = $(this).val();
            if (programme == 'UG') {
                $('#semester').empty();
                $('#semester').append('<option value="" disabled selected>Choose Semester</option>');
                $('#semester').append('<option value="1">1st Semester</option>');
                $('#semester').append('<option value="2">2nd Semester</option>');
                $('#semester').append('<option value="3">3rd Semester</option>');
                $('#semester').append('<option value="4">4th Semester</option>');
                $('#semester').append('<option value="5">5th Semester</option>');
                $('#semester').append('<option value="6">6th Semester</option>');
                $('#semester').append('<option value="7">7th Semester</option>');
                $('#semester').append('<option value="8">8th Semester</option>');
            }
            else {
                $('#semester').empty();
                $('#semester').append('<option value="" disabled selected>Choose Semester</option>');
                $('#semester').append('<option value="1">1st Semester</option>');
                $('#semester').append('<option value="2">2nd Semester</option>');
                $('#semester').append('<option value="3">3rd Semester</option>');
                $('#semester').append('<option value="4">4th Semester</option>');
            }
        });

        $(document).on("click", '#edit_btn', function (e) {
            var semester = {{ course.semester }};
            //alert(semester);
            var programme = $('#selectedprogramme').val();
            //alert(programme);
            if (programme == 'UG') {
                $('#semester').empty();
                $('#semester').append('<option value="" disabled selected>Choose Semester</option>');
                $('#semester').append('<option value="1">1st Semester</option>');
                $('#semester').append('<option value="2">2nd Semester</option>');
                $('#semester').append('<option value="3">3rd Semester</option>');
                $('#semester').append('<option value="4">4th Semester</option>');
                $('#semester').append('<option value="5">5th Semester</option>');
                $('#semester').append('<option value="6">6th Semester</option>');
                $('#semester').append('<option value="7">7th Semester</option>');
                $('#semester').append('<option value="8">8th Semester</option>');
            }
            else {
                $('#semester').empty();
                $('#semester').append('<option value="" disabled selected>Choose Semester</option>');
                $('#semester').append('<option value="1">1st Semester</option>');
                $('#semester').append('<option value="2">2nd Semester</option>');
                $('#semester').append('<option value="3">3rd Semester</option>');
                $('#semester').append('<option value="4">4th Semester</option>');
            }
            $('#semester').val(semester);
        });


        $(document).on("focusout", '#courseid', function (e) {
            var courseid = $(this).val();
            var viewingid = $('#viewingid').val();
            if (courseid.toUpperCase() == viewingid) {
                return;
            }


            $.ajax({
                type: "POST",
                data: {
                    courseid: courseid.toUpperCase(),
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'add_course_to_db' %}',

                success: function (data) {
                    //alert(data.list);
                    if (data.list == 'true') {
                        alert('Course ID already exists');
                        $('#courseid').val('');
                        $('#courseid').focus();
                    }
                }
            });

        });

        $(document).on("click", '#submit', function (e) {
            var courseid = $('#deleteid').val();


            $.ajax({
                type: "POST",
                data: {
                    deleteid: courseid,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'view_course_to_db' %}',

                success: function (data) {
                    window.location = '{% url 'add_course_to_db' %}';
                }
            });

        });

        $(document).on("submit", '#submit_form', function (e) {
            e.preventDefault();
            var courseid = $('#courseid').val();

            var regex = new RegExp("^([A-Za-z0-9]+)$");

            if(!regex.test(courseid)){
                alert('Course ID should contains only letters and numbers!');
                return;
            }

            $('#submit_form').submit();

        });

    </script>

{% endblock %}